/**************************************************************************//**
 * \file 		type.h
 * \brief 	 ,    .
 * \author	 ..
 * \author	email: adnega@mail.ru
 * \author	(C) , 2015
 * \version	v0.1
 * \date 		12.03.2015
 *****************************************************************************/
#ifndef	__TYPE_H__
#define	__TYPE_H__

/******************************************************************************
 *	DEFINE
 *****************************************************************************/
typedef	unsigned char		BYTE;										//!<   8-.
typedef	unsigned short	WORD;										//!<   16-.
typedef unsigned long		DWORD;									//!<   32-.
typedef volatile unsigned long	tTIMER;					//!<   32-.

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
																//!    UDP- (5001)
#define	ETH_TABLO_CONTROL_PORT	(5001)

#define NAME_SIZE			(32)			//!<    (32)
#define RNUM_SIZE			(256)			//!<    NUM (256)
#define CNUM_SIZE			(256)			//!<    CNUM (256)
#define NVNUM_SIZE		(256)			//!<    NVNUM (256)
#define RSTR_NUM			(32)			//!<    RSTR (32)
#define RSTR_SIZE			(128)			//!<    RSTR (128)
#define CSTR_NUM			(32)			//!<    CSTR (32)
#define CSTR_SIZE			(128)			//!<    CSTR (128)
#define NVSTR_NUM			(2)				//!<    NVSTR (2)
#define NVSTR_SIZE		(1024)		//!<    NVSTR (1024)
#define TIMER_NUM			(64)			//!<    TIMER (64)

#define TO_UDP_DEBUG	(30000UL)	//!<    , . (30 ).

//-----------------------------------------------------------------------------
//! \struct sMAC_ADR
//! \brief MAC-
//!   MAC- \ref PAGE_ADDR
//-----------------------------------------------------------------------------
typedef struct sMAC_ADR
{
	union
	{
		struct
		{
			WORD		id;								//!<  2   ID-ID:SR-SR-SR-SR
			DWORD		serial;						//!<  4   ID-ID:SR-SR-SR-SR
		};
		struct
		{
			DWORD		dw;								//!<    
			WORD		w;								//!<    
		};
		BYTE			a[6];							//!<  
	};
} sMAC_ADR;

//-----------------------------------------------------------------------------
//! \struct sIP_ADR
//! \brief IP- ( , )
//!   IP- \ref PAGE_ADDR
//-----------------------------------------------------------------------------
typedef struct sIP_ADR
{
	union
	{
		DWORD			ip;								//!<    
		BYTE			a[4];							//!<  
	};
} sIP_ADR;

//-----------------------------------------------------------------------------
//! \enum eRPF_STR
//! \brief    
//-----------------------------------------------------------------------------
enum eRPF_STR
{
	PRF_STR_NONE = 0,							//!<    (0) [ ]
	PRF_STR_LEFT,									//!<     (1)
	PRF_STR_CENTER,								//!<    (2)
	PRF_STR_RIGHT,								//!<     (3)
	PRF_STR_LSCROLL,							//!<        (4)
	PRF_STR_CSCROLL,							//!<       (5)
	PRF_STR_RSCROLL,							//!<        (6)
	PRF_STR_LOW,									//!<      (7)
	PRF_STR_MEDIUM,								//!<      (8)
	PRF_STR_HIGH,									//!<      (9)
	PRF_STR_SPEED,								//!<      [ ]
};

//-----------------------------------------------------------------------------
//! \enum eTIMER_STATE
//! \brief / 
//-----------------------------------------------------------------------------
enum eTIMER_STATE
{
	TIMER_STATE_STOP = 0,					//!<   /   (0)
	TIMER_STATE_RUN,							//!<   /   (1)
	TIMER_STATE_RESTART,					//!< ... /   (2)
};

//-----------------------------------------------------------------------------
//! \struct sTIMER
//! \brief   
//-----------------------------------------------------------------------------
typedef struct sTIMER
{
	DWORD				current;					//!<   
	DWORD				from;							//!<   
	DWORD				to;								//!<   
	BYTE				cur_state;				//!<   
	BYTE				new_state;				//!<   
	union
	{
		WORD			flags;						//!<  
		struct
		{
			WORD		f_restart:1;			//!<   (0)
			WORD		f_siren:1;				//!<   (1)
			WORD		f_hide:1;					//!<   (2)
																//!      (3)
			WORD		f_hide_inactive:1;
			WORD		f_slave:1;				//!<   (4)
			WORD		f_master:3;				//!<   (7-5)
			WORD		f_reserv:8;				//!<  (15-8)
		};
	};
} sTIMER;

//-----------------------------------------------------------------------------
//!	\enum eAUTOBRIGHT
//! \brief   
//-----------------------------------------------------------------------------
enum eAUTOBRIGHT
{
	AUTOBRIGHT_ON = 0,						//!<   (0)
	AUTOBRIGHT_OFF,								//!<   (1)
};

/**************************************************************************//**
\mainpage     .
\note       \b u653 ().
\author  ..\n
email: adnega@mail.ru
\version v0.2
\date 15.06.2016.

\line _

\section SEC_LINK   .

        Ethernet.     UDP- ( UDP/IP).

   :
-   ,
-      (,        ),
-    (,      ).

    UDP- #ETH_TABLO_CONTROL_PORT.
    ,        .

 (\a IP- - IP-  ; \a UDP- - UDP-   ; \a IP- - IP- ):
- \b " " \a IP- : \a UDP- -> \a IP- : #ETH_TABLO_CONTROL_PORT.
- \b " " \a IP- : #ETH_TABLO_CONTROL_PORT -> \a IP- : \a UDP-.

      :
- \a  ;
- \a  .

 \a     \b ETH_GET_ (   \b sPACKET_GET_). \n
 \a     \b ETH_SET_ (   \b sPACKET_SET_). \n
    \a     \a   ,   \b ETH_ANS_ (   \b sPACKET_ANS_).

       #ETH_SET_MODE ( sPACKET_SET_MODE). \n

\warning   ,            .

\line _

\section SEC_OBJECTS  .

      .  ,   Ethernet, :
- \b NVSTR -  ASCII-Z  (   ).   \b NVSTR #NVSTR_SIZE.   \b NVSTR #NVSTR_NUM.
- \b RSTR -  ASCII-Z  (   , ).   \b RSTR #RSTR_SIZE.   \b RSTR #RSTR_NUM.
- \b CSTR -  ASCII-Z  (   ,    ).   \b CSTR #CSTR_SIZE.   \b CSTR #CSTR_NUM.
- \b NVNUM -  32-  (   ).   \b NVNUM #NVNUM_SIZE.
- \b RNUM -  32-  (   , ).   \b RNUM #RNUM_SIZE.
- \b CNUM -  32-  (   ,    ).   \b CNUM #CNUM_SIZE.
- \b TIMER -     .   \b TIMER #TIMER_NUM.

    \a  ()  \a  () (  \b CSTR  \b CNUM).

    .          .
   .    ,     .
      \b 0xFF  \b NVSTR, \b RSTR, \b CSTR, \b TIMER,  \b 0xFFFF  \b NVNUM, \b RNUM, \b CNUM.

   \b RSTR:
- \a  : \n
\b index - 0, 1, 12, 30, 78, 0xFF, 0xFF, 0xFF -     0, 1, 12, 30, 78.
- \a  : \n
\b index - 0, 1, 12, 30, 0xFF (.. 78  RSTR  ), 0xFF, 0xFF, 0xFF; \n
\b profile -     0, 1, 12, 30, und, und, und, und; \n
\b rstr -     0, 1, 12, 30, '', '', '', ''.

\page PAGE_COMMAND   UDP-.
  UDP-:
- mac - MAC-   \b FF:FF:FF:FF:FF:FF   ;
- cmd -       (\b ETH_CMD_xxx, \b ETH_ANS_xxx);
- type -   #ETH_TABLO_TYPE  #ETH_TABLO_TYPE_BR;
- p_id -  .  ,      ;
- data -  .

\page PAGE_ADDR  MAC  IP.
MAC-      6 .        (big endian) \n
, MAC- 12:34:56:78:90:AB    :
- [0] = 0x12
- [1] = 0x34
- [2] = 0x56
- [3] = 0x78
- [4] = 0x90
- [5] = 0xAB

IP-      4 .        (big endian) \n
, IP- 192.168.0.1    :
- [0] = 192
- [1] = 168
- [2] = 0
- [3] = 1

\note   IP-    IP- (ip),     (mask)   (gw).

\page PAGE_BRIGHT  .
     :
- 0 -  ;
- 1 -  ;
-  2  99 -   ;
- 100 -  .

\page PAGE_DATETIME   .
          01.01.2000 00:00:00.

\page PAGE_CONFIG   .
   :

\section S_SAFE int safe
 .     :
- 0 - ;
- 1 -  CPU ();
- 2 -  PCB ( );
- 3..6 -     ;
- 7 -      .

\note     .

\section S_T_MIN short t_min
     , 1/16 .\n
        ,       "COLD".\n
    -40C.\n
    "-40C": t_min = -40 * 16 = -640.
\note     .

\section S_T_MAX short t_max
     , 1/16 .\n
        ,       "HOT".\n
    +85C.\n
    "+85C": t_max = 85 * 16 = 1360.
\note     .

\section S_TO_WATCHDOG int to_watchdog
   .            ,    .
\warning    600     !

\section S_AUTOBRIGHT DWORD autobright
  .\n
          .
. \ref eAUTOBRIGHT.

\section S_TO_TIMER_SIREN DWORD to_timer_siren
     .

\page PAGE_DEBUG   .
       128   UDP-  IP-,
    ,   5010.     #TO_UDP_DEBUG.
      sPACKET_UDP_DEBUG   #TO_UDP_DEBUG.
   \ref sPACKET_UDP_DEBUG::flags   :
- 0 -  ;
- 1 -   .

******************************************************************************/
#endif // __TYPE_H__
/******************************************************************************
 *  
 *****************************************************************************/
